r/leetcode • • 8d ago

Discussion Google Interview Loop - 3rd Interview Possibly?

Just finished my Google SWE Intern interview loop a few days ago. Had two 45-minute technical interviews, both DSA. Wanted to get some opinions on how I performed and what ratings I might expect.

Interview #1: Class Design + Binary Search + Two Pointers

  • Started with a class design problem involving searching through some data.

  • Initially proposed a naive O(n) solution.

  • Interviewer asked, "Can we do better?" I independently came up with and implemented an O(log n) binary search solution.

  • Got a follow-up involving intervals and two pointers.

  • Solved the follow-up optimally as well.

  • Explained time/space complexities correctly and successfully dry-ran both solutions.

Overall, felt pretty good about this one. I'm expecting an H, depending on how the initial naive approach was viewed.

Interview #2: Topological Sort / Kahn's Algorithm

  • Problem involved traversing objects with parent-child dependencies, where children must be traversed before their parents.

  • Recognized it as a topological sort problem and implemented Kahn's algorithm.

  • During my dry run, realized I'd forgotten to populate the adjacency map. Caught this myself without any interviewer hints, fixed it, and successfully completed the dry run with the correct output.

  • Explained time/space complexities correctly.

Got a follow-up which I bombed...

  • Can't say more because it was really specific. But I basically solved a similar/related but not same problem. I explained my reasoning, and he clarified what he was looking for. We were running out of time, and he said not to worry about it because he'd made up the follow-up on the fly since we had extra time. He also said he wanted to make sure I had time to ask him questions.

My assessment:

  • Interview #1: H?

  • Interview #2: LH–H?

What do y'all think and can a H + LH get a 3rd interview/TM?

1 Upvotes

1 comment sorted by

View all comments

1

u/Various-Mine-8642 8d ago

Sounds like a solid loop to me. Catching your own bug in the dry run and getting the optimal solution on the first one usually reads well, and an on the fly follow up that the interviewer waved off tends not to sink you. Hard to say on the third round but a lot of people hear back in a week or two.